#include <stdio.h>
#include <string.h>
#include <limits.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>

void	printHex( unsigned long color, int x1, int y1, char *str)
{
	char message[999];
	unsigned r1;
	unsigned g1;
	unsigned b1;
	unsigned a1;
	unsigned char r;
	unsigned char g;
	unsigned char b;
	unsigned char a;

	if( strlen( str ) < 800 ) {
		sprintf( message, "%s", str);
	} else {
		sprintf( message, "String too big (%d chars)", strlen(str) );
	}

	r1 = color & 0xFF000000;
	g1 = color & 0x00FF0000;
	b1 = color & 0x0000FF00;
	a1 = color & 0x000000FF;

	a = (char)(a1);
	b = (char)(b1 >> 8);
	g = (char)(g1 >> 16);
	r = (char)(r1 >> 24);

	pspDebugScreenSetXY(x1,y1);
	pspDebugScreenSetTextColor((a * 0x1000000) + (b * 0x10000) + (g * 0x100) + (r));
	pspDebugScreenPrintf(message);
}



void	printRGBA( int r, int g, int b, int a, int x1, int y1, char *str )
{
	char message[999];

	if( strlen( str ) < 800 ) {
		sprintf( message, "%s", str);
	} else {
		sprintf( message, "String too big (%d chars)", strlen(str) );
	}

	pspDebugScreenSetXY(x1,y1);
	pspDebugScreenSetTextColor((a * 0x1000000) + (b * 0x10000) + (g * 0x100) + (r));
	pspDebugScreenPrintf(message);
}

void	printHexC( unsigned long color, int x1, int x2, int y, char *str )
{
	int	length, currentLine;
	int	foundEnd = FALSE;
	char	tempStr[999];
	char	tempStr2[999];
	char	theMessage[999];
	int	xWidth;
	char	*ptr;
	char	*ptr2;

	xWidth = x2 - x1;
	length = strlen( str );
	if( length>=800 ) {
		sprintf( theMessage, "String too big (%d chars)", strlen(str) );
		printHex(color, x1, y, theMessage);
	}
	if( length<=xWidth ) {
		printHex(color, ((xWidth-length)/2) + x1, y, str);
	} else {
		currentLine = 0;
		strcpy(theMessage, str);
		while( !foundEnd ) {
			length = strlen(theMessage);
			tempStr[xWidth] = '\0';
			strncpy( tempStr, theMessage, xWidth );
			ptr2 = strstr( tempStr, "\n" );
			if( ptr2 != NULL ) {
				strncpy( tempStr2, tempStr, (ptr2-tempStr));
				tempStr2[(ptr2-tempStr)]='\0';
				printHex(color, (((xWidth-strlen(tempStr2))/2)+((xWidth-strlen(tempStr2))%2))+x1, y+currentLine, tempStr2);
				strcpy( tempStr2, theMessage );
				strcpy( theMessage, &tempStr2[(ptr2-tempStr)+1]);
				theMessage[length-((ptr2-tempStr)+1)] = '\0';
			} else {
				ptr = strrchr( tempStr, ' ' );
				if( ptr == NULL ) {
					printHex(color, x1, y+currentLine, tempStr);
					printHex(color, (x1 + xWidth) - 1, y+currentLine, "-");
					strcpy( tempStr2, theMessage );
					strcpy( theMessage, &tempStr2[xWidth-1] );
					theMessage[length-(xWidth-1)] = '\0';
				} else {
					strncpy( tempStr2, tempStr, (ptr - tempStr) + 1);
					tempStr2[(ptr - tempStr + 1) ] = '\0';
					printHex(color, ( (( xWidth-(ptr-tempStr+1))/2)+((xWidth-(ptr-tempStr+1))%2) ) + x1, y + currentLine, tempStr2);
					strcpy( tempStr2, theMessage );
					strcpy( theMessage, &tempStr2[ptr - tempStr + 1] );
					theMessage[length-(ptr - tempStr + 1)] = '\0';
				}
			}
			if( strlen( theMessage ) <=xWidth ) {
				foundEnd=TRUE;
			}
			currentLine++;
		}
		foundEnd=FALSE;
		while( !foundEnd ) {
			length = strlen(theMessage);
			strcpy(tempStr, theMessage);
			tempStr[length] = '\0';
			ptr2 = strstr( tempStr, "\n" );
			if( ptr2 != NULL ) {
				strncpy( tempStr2, tempStr, (ptr2-tempStr));
				tempStr2[(ptr2-tempStr)]='\0';
				printHex(color, (((xWidth-(strlen( theMessage )))/2)+((xWidth-(strlen( theMessage )))%2)) + x1, y + currentLine, tempStr2);
				currentLine++;
				strcpy( tempStr2, theMessage );
				strcpy( theMessage, &tempStr2[(ptr2-tempStr)+1]);
				theMessage[length-((ptr2-tempStr)+1)] = '\0';
			} else {
				foundEnd = TRUE;
			}
		}
		printHex(color, (((xWidth-(strlen( theMessage )))/2)+((xWidth-(strlen( theMessage )))%2)) + x1, y + currentLine, theMessage);
	}
}

void	printHexCBox( unsigned long color1, unsigned long color2, int x1, int x2, int y, char *str )
{
	char	tempStr[999];
	int	length, xWidth, startX, tempI;
	length = strlen(str);
	xWidth = x2 - x1;
	startX = (((xWidth-length)/2)+((xWidth-length)%2))+x1-2;
	sprintf(tempStr, "%c", 24);
	printHex(color1, startX, y-1, tempStr);
	sprintf(tempStr, "%c", 23);
	for( tempI=startX+1; tempI<startX+1+length; tempI++ ) {
		printHex(color1, tempI, y-1, tempStr);
	}
	sprintf(tempStr, "%c", 25);
	printHex(color1, startX+1+length, y-1, tempStr);

	sprintf(tempStr, "%c", 22);
	printHex(color1, startX, y, tempStr);
	printHex(color2, startX+1, y, str);
	sprintf(tempStr, "%c", 22);
	printHex(color1, startX+1+length, y, tempStr);
	
	sprintf(tempStr, "%c", 26);
	printHex(color1, startX, y+1, tempStr);
	sprintf(tempStr, "%c", 23);
	for( tempI=startX+1; tempI<startX+1+length; tempI++ ) {
		printHex(color1, tempI, y+1, tempStr);
	}
	sprintf(tempStr, "%c", 27);
	printHex(color1, startX+1+length, y+1, tempStr);

}

unsigned	time_seed (void)
{
	// Usage: srand (time_seed ());

	time_t timeval;
	unsigned char *ptr;
	unsigned seed;
	size_t tempI;

	timeval = time (NULL);
	ptr = (unsigned char *) &timeval;

	seed = 0;
	for (tempI = 0; tempI < sizeof timeval; tempI++) {
		seed = seed * (UCHAR_MAX + 2u) + ptr[tempI];
	}

	return seed;
}
